#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Dos2Word.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Comment=Homepage: http://www.mcmilk.de/projects/Dos2Word/
#AutoIt3Wrapper_Res_Description=DOS Text nach Word Konverter
#AutoIt3Wrapper_Res_Fileversion=0.0.0.1
#AutoIt3Wrapper_Res_ProductVersion=0.0.0.1
#AutoIt3Wrapper_Res_LegalCopyright=© 2016 Tino Reichardt
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Res_Field=Productname|Dos2Word
#AutoIt3Wrapper_Res_Field=CompanyName|Tino Reichardt
#AutoIt3Wrapper_Res_Field=Compile Date|%date% %time%
#AutoIt3Wrapper_Run_After=echo %fileversion% > prog.txt
#AutoIt3Wrapper_Run_After=mpress -q -r -s Dos2Word.exe
#AutoIt3Wrapper_Run_After=mpress -q -r -s Dos2Word_x64.exe
#AutoIt3Wrapper_Run_After=signtool sign /v /tr http://time.certum.pl/ /f Dos2Word.p12 /p pass Dos2Word.exe
#AutoIt3Wrapper_Run_After=signtool sign /v /tr http://time.certum.pl/ /f Dos2Word.p12 /p pass Dos2Word_x64.exe
#AutoIt3Wrapper_Run_Tidy=y
#AutoIt3Wrapper_Run_Au3Stripper=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#cs
	Copyright © 2016 Tino Reichardt

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License Version 2, as
	published by the Free Software Foundation.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
#ce

; ctime: /TR 2016-03-11
; mtime: /TR 2016-03-13

Opt("MustDeclareVars", 1)
Opt("TrayIconHide", 1)
Opt("TrayMenuMode", 3)

#include <Array.au3>
#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <Misc.au3>
#include <File.au3>
#include <FileConstants.au3>
#include <MsgBoxConstants.au3>
#include <StringConstants.au3>
#include <TrayConstants.au3>
#include <WinAPI.au3>
#include <WinAPICom.au3>
#include <WinAPIFiles.au3>
#include <WindowsConstants.au3>
#include <Word.au3>

; Titel, Name und so weiter definieren...
Global Const $sAppName = "Dos2Word"
Global Const $sTitle = " " & $sAppName
Global Const $sVersion = "0.1"
Global Const $sIniFile = @AppDataDir & "\" & $sAppName & "\" & $sAppName & ".ini"

; Static Tray Variables
Global $iAbout, $iExit, $iEditSettings

; Static Lang Variables
Global $sMsgEdit
Global $sMsgAbout
Global $sMsgExit
Global $sMsgInfo
Global $sMsgStarted

; Options
Global $sEditor = "notepad.exe"
Global $sWordSettings = "..."
Global $sFilesDelete = "1"
Global $sWaitForFile = "300"

; Default Word Settings
Global $sCodePage = "437"
Global $sFontName = "Lucida Console"
Global $sFontSize = "6"
Global $sPageHeight = "29,7cm"
Global $sPageWidth = "21cm"
Global $sTopMargin = "1,5cm"
Global $sBottomMargin = "1,5cm"
Global $sLeftMargin = "1,5cm"
Global $sRightMargin = "1,5cm"
Global $sFilePath = "C:\CM1\output.txt"

; TrayMenu
Global $aTrayItems[1] = [0]; alle ID's der Tray Controls
Global $aWordSettings[1] = [0]; unterschiedliche Word Einstellungen

Func ReadConfiguration()

	; first time start, create some sample entries
	If Not FileExists(@AppDataDir & "\" & $sAppName) Then
		DirCreate(@AppDataDir & "\" & $sAppName)
		$sWordSettings = "Plan1"
		WriteConfiguration()
		$sWordSettings = "Plan2"
		WriteConfiguration()
		$sWordSettings = "DefineMore"
		WriteConfiguration()
	EndIf

	; Optionen
	Local $sSection = "Options"
	$sEditor = IniRead($sIniFile, $sSection, "Editor", $sEditor)
	$sFilesDelete = IniRead($sIniFile, $sSection, "FilesDelete", $sFilesDelete)
	$sWordSettings = IniRead($sIniFile, $sSection, "WordSettings", $sWordSettings)
	$sWaitForFile = IniRead($sIniFile, $sSection, "WaitForFile", $sWaitForFile)

	; IniReadSectionNames
	Local $aTemp = IniReadSectionNames($sIniFile)
	ReDim $aWordSettings[1]
	If Not @error Then
		For $i = 1 To $aTemp[0]
			If $aTemp[$i] = "Options" Then ContinueLoop
			_ArrayAdd($aWordSettings, $aTemp[$i])
		Next
	EndIf
	$aWordSettings[0] = UBound($aWordSettings) - 1

	; IniReadSectionNames
	$sSection = $sWordSettings
	$sFilePath = IniRead($sIniFile, $sSection, "FilePath", $sFilePath)
	$sCodePage = IniRead($sIniFile, $sSection, "CodePage", $sCodePage)
	$sFontName = IniRead($sIniFile, $sSection, "FontName", $sFontName)
	$sFontSize = IniRead($sIniFile, $sSection, "FontSize", $sFontSize)
	$sPageHeight = IniRead($sIniFile, $sSection, "PageHeight", $sPageHeight)
	$sPageWidth = IniRead($sIniFile, $sSection, "PageWidth", $sPageWidth)
	$sTopMargin = IniRead($sIniFile, $sSection, "TopMargin", $sTopMargin)
	$sBottomMargin = IniRead($sIniFile, $sSection, "BottomMargin", $sBottomMargin)
	$sLeftMargin = IniRead($sIniFile, $sSection, "LeftMargin", $sLeftMargin)
	$sRightMargin = IniRead($sIniFile, $sSection, "RightMargin", $sRightMargin)

	; Register Convert Function
	AdlibUnRegister("Convert2Word")
	AdlibRegister("Convert2Word", $sWaitForFile)

	; just write an cleanup version after parsing...
	WriteConfiguration()
EndFunc   ;==>ReadConfiguration

Func ReadLanguages()
	Local $sIniLang = @AppDataDir & "\" & $sAppName & "\Languages.ini"
	; Create known Translations
	If Not FileExists($sIniLang) Then
		; german
		Local $a[6][2] = [[5, ""], ["0", "Konfiguration"], ["1", "Über"], ["2", "Beenden"], ["3", "DOS Ausdruck -> Word Konverter"], ["4", "Schon gestartet?"]]
		IniWriteSection($sIniLang, "Lang0407", $a)
	EndIf

	Local $sSection = "Lang" & @OSLang
	$sMsgEdit = IniRead($sIniLang, $sSection, "0", "Configuration")
	$sMsgAbout = IniRead($sIniLang, $sSection, "1", "About")
	$sMsgExit = IniRead($sIniLang, $sSection, "2", "Exit")
	$sMsgInfo = IniRead($sIniLang, $sSection, "3", "DOS Printing -> Word Converter")
	$sMsgStarted = IniRead($sIniLang, $sSection, "4", "Already started?")
EndFunc   ;==>ReadLanguages

Func WriteConfiguration()
	; Optionen
	Local $sSection = "Options"
	IniReadSection($sIniFile, $sSection)
	Local $iError = @error
	IniWrite($sIniFile, $sSection, "Editor", $sEditor)
	IniWrite($sIniFile, $sSection, "FilesDelete", $sFilesDelete)
	IniWrite($sIniFile, $sSection, "WordSettings", $sWordSettings)
	IniWrite($sIniFile, $sSection, "WaitForFile", $sWaitForFile)
	If $iError <> 0 Then
		FileWriteLine($sIniFile, "")
		FileWriteLine($sIniFile, "; Folgende Fonts kann man verwenden /TR")
		FileWriteLine($sIniFile, "; Fixed Size Fonts: Consolas|Lucida Console|Courier New")
		FileWriteLine($sIniFile, "")
	EndIf

	; Word Einstellungen
	$sSection = $sWordSettings
	IniReadSection($sIniFile, $sSection)
	Local $iError = @error
	IniWrite($sIniFile, $sSection, "FilePath", $sFilePath)
	IniWrite($sIniFile, $sSection, "CodePage", $sCodePage)
	IniWrite($sIniFile, $sSection, "FontName", $sFontName)
	IniWrite($sIniFile, $sSection, "FontSize", $sFontSize)
	IniWrite($sIniFile, $sSection, "PageHeight", $sPageHeight)
	IniWrite($sIniFile, $sSection, "PageWidth", $sPageWidth)
	IniWrite($sIniFile, $sSection, "TopMargin", $sTopMargin)
	IniWrite($sIniFile, $sSection, "BottomMargin", $sBottomMargin)
	IniWrite($sIniFile, $sSection, "LeftMargin", $sLeftMargin)
	IniWrite($sIniFile, $sSection, "RightMargin", $sRightMargin)
	If $iError <> 0 Then FileWriteLine($sIniFile, "")
EndFunc   ;==>WriteConfiguration

Func DisableTrayMenu()
	For $i = 1 To $aTrayItems[0]
		TrayItemDelete($aTrayItems[$i])
	Next
	ReDim $aTrayItems[1]
	$aTrayItems[0] = 0
EndFunc   ;==>DisableTrayMenu

Func EnableTrayMenu()
	DisableTrayMenu()
	Local $c

	For $i = 1 To $aWordSettings[0]
		$c = TrayCreateItem(String($aWordSettings[$i]), -1, -1, 1)
		_ArrayAdd($aTrayItems, $c)
		If StringCompare($aWordSettings[$i], $sWordSettings) = 0 Then TrayItemSetState($c, $TRAY_CHECKED)
	Next
	$c = TrayCreateItem("") ; separator line
	_ArrayAdd($aTrayItems, $c)
	$iEditSettings = TrayCreateItem($sMsgEdit)
	_ArrayAdd($aTrayItems, $iEditSettings)
	$iAbout = TrayCreateItem($sMsgAbout)
	_ArrayAdd($aTrayItems, $iAbout)
	$iExit = TrayCreateItem($sMsgExit)
	_ArrayAdd($aTrayItems, $iExit)

	; ab nun haben wir nen tray
	$aTrayItems[0] = UBound($aTrayItems) - 1
	TraySetState($TRAY_ICONSTATE_SHOW)
EndFunc   ;==>EnableTrayMenu

; baut uns ein kleines schickes Tray zusammen
Func TrayInitMenu()
	EnableTrayMenu()
	TraySetToolTip($sTitle)

	While 1
		Local $msg = TrayGetMsg()
		Switch $msg
			Case 0, $GUI_EVENT_MOUSEMOVE, $GUI_EVENT_PRIMARYDOWN, $GUI_EVENT_PRIMARYUP, $GUI_EVENT_SECONDARYDOWN, $GUI_EVENT_SECONDARYUP
				; ignore these

			Case $iEditSettings
				DisableTrayMenu()
				RunWait($sEditor & " " & $sIniFile)
				ReadConfiguration()
				EnableTrayMenu()

			Case $iAbout
				Local $sText = @CRLF & $sMsgInfo
				$sText &= @CRLF & "© 2016 Tino Reichardt"
				TrayTip($sAppName & " " & $sVersion, $sText, 10, $TIP_ICONASTERISK)

			Case $iExit
				Exit

			Case Else
				; für alle dynamischen ID's
				; -> 4 weniger, weil Trennstrich + Konfig + Über + Beenden
				For $i = 1 To $aTrayItems[0] - 4
					If $aTrayItems[$i] = $msg Then
						TrayItemSetState($aTrayItems[$i], $TRAY_CHECKED)
						$sWordSettings = $aWordSettings[$i]
						IniWrite($sIniFile, "Options", "WordSettings", $sWordSettings)
						ReadConfiguration()
					EndIf
				Next
		EndSwitch
	WEnd
EndFunc   ;==>TrayInitMenu

Func ErrorExit($sError)
	MsgBox($MB_SYSTEMMODAL, $sTitle, $sError & @CRLF & "@error = " & @error & ", @extended = " & @extended)
	Exit
EndFunc   ;==>ErrorExit

Func Convert2Word()
	; keine datei da...
	If Not FileExists($sFilePath) Then Return

	; noch in Beaarbeitung...
	If _WinAPI_FileInUse($sFilePath) Then Return

	; nun aber...
	Local $sFilePathTemp = $sFilePath & "_" & _WinAPI_CreateGUID() & ".txt"
	FileMove($sFilePath, $sFilePathTemp, $FC_OVERWRITE)

	; open word and create new document
	Local $oWord = _Word_Create()
	If @error Then ErrorExit("Fehler bei _Word_Create()")
	Local $oDoc = _Word_DocAdd($oWord)
	If @error Then ErrorExit("Fehler bei _Word_DocAdd()")

	; seite definieren
	With $oDoc.PageSetup
		.PageHeight = $sPageHeight
		.PageWidth = $sPageWidth
		.TopMargin = $sTopMargin
		.BottomMargin = $sBottomMargin
		.LeftMargin = $sLeftMargin
		.RightMargin = $sRightMargin
	EndWith

	; schrift und absatz
	With $oDoc.Range
		.Font.Name = $sFontName
		.Font.Size = $sFontSize
	EndWith
	With $oDoc.Range.ParagraphFormat
		.SpaceBefore = 0
		.SpaceAfter = 0
		.LineUnitBefore = 0
		.LineUnitAfter = 0
		.LineSpacingRule = 0
	EndWith

	Local $hFile = FileOpen($sFilePathTemp, BitOR($FO_READ, $FO_BINARY))
	Local $iError
	Local $iLine = 1
	Do
		Local $sLine = FileReadLine($hFile, $iLine)
		$iError = @error
		$iLine += 1

		; ignore special escape line of cm.exe
		If StringLeft($sLine, 2) = Chr(27) & Chr(64) Then $sLine = StringTrimLeft($sLine, 2)

		$oDoc.Range.insertAfter(_WinAPI_MultiByteToWideChar($sLine, $sCodePage, 0, True) & @CRLF)
	Until $iError <> 0

	; und am ende löschen, sofern gewünscht
	FileClose($hFile)
	If $sFilesDelete <> "0" Then FileDelete($sFilePathTemp)
EndFunc   ;==>Convert2Word

; wenn es schon läuft, nix weiter machen...
If _Singleton($sTitle, 1) = 0 Then
	MsgBox($MB_OK, $sTitle, $sMsgStarted)
	Exit
EndIf

ReadConfiguration()
ReadLanguages()
TrayInitMenu()
